;---Global settings:

;---Default value for the $BD register. (controls vibrato/am depth, default is set to zero)

fmdepth
	.byte $00

;---ADSR global curve tables:  (remember FM ADSR is in reverse order to SID)

fmattack_replace	
	.byte $b0,$a0,$90,$80,$70,$60,$60,$50,$50,$40,$40,$30,$20,$20,$10,$00
	
fmdecay_replace	
	.byte $0b,$0a,$09,$08,$07,$06,$06,$05,$05,$04,$04,$03,$02,$02,$01,$00	
      
fmsustain_replace		
         .byte $b0,$a0,$90,$80,$60,$40,$30,$20,$20,$20,$10,$10,$10,$00,$00,$00

fmrelease_replace		
	 .byte $0b,$0a,$09,$08,$07,$06,$06,$05,$05,$04,$04,$03,$03,$02,$02,$01
     
         
;---Output volume curve table:  (remember FM volumes are in reverse order to SID and go from $00-$3f)

fmvolume_replace
	
	.byte $3f,$24,$17,$13,$0f,$0b,$09,$08,$07,$06,$05,$04,$03,$02,$01,$00

;---Fixed noise value, used if FIXEDNOISE is enabled in fmx-build.asm

fixed_noise_value
	.byte $6f
	
;---Default wait delay for each FM send.  You can probably go as low as 03 here, anything lower is not recommended.

fmwaitdelay
	.byte $04

;---Patched sid buffer, needs 1kb of memory. (doesn't need to be continuous)  Uses space in $9c00-$9fff by default.
patch_memory
	.byte $9c,$9d,$9e,$9f

;---Screen GUI settings: (only used when DEBUGMODE is disabled in fmx-build.asm

; Raster position of the screen.
rasterposition
	.byte $38

; Screen raster colour (set this and the border to the same colour to remove raster display)
color_raster
	.byte $0e
; Screen border colour
color_border
	.byte $00	
; Screen page colour
color_page
	.byte $00
; Screen ink colour
color_ink
	.byte $03

;---Cycle delay routine used when writing to the FM chip.	
nopfest	
	nop
	nop
	nop
	nop
	sta $df50
	txa
	pha
	ldx fmwaitdelay
nopfest2
	nop
	dex
	bne nopfest2
	pla
	tax
	rts	