
;---Song setup:
; This is where you setup how FMX will use your song(s) for each of the 4 passes.
; For each setting $ff means skip this pass.

;---Step 1 : Patch song files.
; This info is used by the song patcher.

; Put in the load address high byte of your song here. (eg: if it loads at $1000, put $10 in.  if it's loads at $1480, put $14 in)
player_patchsid
	.byte $10,$ff,$ff,$ff

; This is the amount of pages (256 bytes) the patching process checks.  The default ($08 = 2kb) seems fine for most modern players.
player_patchsid_threshold
	.byte $08,$08,$08,$08 

;---Step 2 : Song playback.
; This is where you tell FMX how your songs init and play.
	
; Song init (hibyte/lowbyte)  In modern players this is usually the same as the load address.
player_inithi
	.byte $10,$ff,$ff,$ff
player_initlo
	.byte $00,$00,$00,$00

; Song play frame (hibyte/lowbyte)  In modern players this is usually 3 bytes after the load address.
player_playhi
	.byte $10,$ff,$ff,$ff
player_playlo
	.byte $03,$03,$03,$03

;---Step 3 : Input and output.
; This is where you tell FMX what devices to playback your song on.

; What sid chip address to read from on each pass.	
player_readsidhi
	.byte $d4,$ff,$ff,$ff
player_readsidlo
	.byte $00,$ff,$ff,$ff

; If this pass should be sent to the FM cartrige. Set to $00 for yes, $ff to skip.
player_fmout
	.byte $00,$ff,$ff,$ff

; What sid chip address to write to on each pass.  Set to $ff to skip. 
player_outputhi
	.byte $ff,$ff,$ff,$ff
player_outputlo
	.byte $ff,$ff,$ff,$ff
	
;---Step 4 : Compatibility settings

; If using different song editors together you may need to delay some of them a few frames to sync together.  
; If the value isn't $ff that driver will run this number of frames before the songs start playing together.
player_startoffset
	.byte $ff,$ff,$ff,$ff

; If for some reason you want to call a sub-tune in your track instead of the default zero.
player_song
	.byte $00,$00,$00,$00
	
; This enables the advanced playback mode per FM channel.  It takes a *lot* more rastertime as it resends the
; instrument so only use it on channels that have a problem.  For 3 channel songs you can use it on all channels without problems.
channel_advanced_hardrestart
	.byte $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff

;---Step 5 : Screen display
; This is where you can put in the credits for your song.  Lower case, numbers and punctuation supported.  
; Finish each line with a byte $00 as below.

songname
	.byte "song name"
	.byte $00
author
	.byte "song author"
	.byte $00
release
	.byte "song release date"
	.byte $00

;---Step 6 : Add your songs to the memory map.
; By default songs can be placed in memory between $1000-$6fff, $a000-bfff, $c000-cfff and (if the file is crunched) $e000-$ffff.
; You will probably only ever need the lowest ram space though.
; Song files need to be in standard c64 .prg or .bin format
; .prg - Add -2 to the end of the org line to skip the header
; .bin - Leave org address as is.

	org $1000-2 ; memory load position of song.
	.incbin testloop.prg

; The default memory map is:		
; $0801-$0fff - FMX Code.
; $1000-$6fff - Free
; $7000-$9fff - FMX Data
; $a000-$cfff - Free
; $e000-$ffff - Potentially free if you crunch the file.