
; FMX version 1.0
; 4mat / ate bit - 11-11-2017
; DASM format source

	processor 6502

	.include fmx-build.asm
	
	org	$0801
	.IF BUILDHEADER = 1
	.byte	$0b,$08,$c6,$0d,$9e,$32,$30,$36,$32,0,0,0,0
	org	$080e
	.ENDIF

	.IF REPLAYMODE = 0	
	sei

	lda #$35
	sta $01
	
	jsr frontend
	
	
	jsr fmx_init
	
	; mainloop
	
mainloop


	
	.IF DEBUGMODE = 1
	lda #$0e
	sta $d020

	lda $dc01
	cmp #$ef
	beq skipraster
	.ENDIF
	.IF DEBUGMODE = 0
	lda color_border
	sta $d020
	.ENDIF
mainraster
	lda $d012
	cmp rasterposition
	bne mainraster

skipraster	

	.IF DEBUGMODE = 0
	lda color_raster
	sta $d020

	.ENDIF	
	.IF DEBUGMODE = 1
	lda #$0b
	sta $d020
	.ENDIF
	
	jsr fmx_play
	
	jmp mainloop

	.ENDIF

	jmp fmx_init
	jmp fmx_play
	
	; init song	
fmx_init
	jsr patch_sids


	; sid/fm init
	
	.IF FORCESUSTAINSTART = 1
	ldx #$08
	lda #$01
setfirstpass	
	sta firstpass,x
	dex 
	bpl setfirstpass
	.ENDIF
	
	ldx #$00
	txa
clearsidregs
	sta sidregs,x
	inx
	cpx #$c8
	bne clearsidregs

	ldx #$00
clearfm
	txa
	clc
	adc #$a0
	sta $df40
	lda #$00
	jsr nopfest
	txa
	clc
	adc #$b0
	sta $df40
	lda #$00
	jsr nopfest
	inx
	cpx #$09
	bne clearfm


	
	lda #$bd
	sta $df40
	lda fmdepth
	jsr nopfest


	
	lda #$00
	sta fmupdate_inittoggle+$01

	ldx #$00
sidinit
	stx drivernumber
	lda player_inithi,x
	sta driver_callhi,x
	lda player_initlo,x
	sta driver_calllo,x
	lda player_song,x
	sta driverrun+$01


	jsr sid_readmain
	

	jsr fm_play

waitinit
	lda $d012
	cmp rasterposition
	bne waitinit
	ldx drivernumber
	inx
	cpx #$04
	bne sidinit
	
	jsr register_flip
	
	
	lda #$ff
	sta fmupdate_inittoggle+$01
	
	ldx #$03
sidinit2
	lda player_playhi,x
	sta driver_callhi,x
	lda player_playlo,x
	sta driver_calllo,x
	dex
	bpl sidinit2

	; handle delay waits

checkdelay
	ldx #$00	
	stx playerdelaycheck
checkdelayloop
	stx drivernumber
	lda player_startoffset,x
	bpl checkdelaydo
	inc playerdelaycheck
	jmp checkdelayskip
checkdelaydo
	
	dec player_startoffset,x
	
	
	jsr sid_readmain
	
	
checkdelayskip
	ldx drivernumber
	inx
	cpx #$04
	bne checkdelayloop
	
	;jsr register_flip
	
	lda playerdelaycheck
	cmp #$04
	bne checkdelay
	
	rts

	; driver play

fmx_play
	jsr sid_read

	; write to fm
	
	jsr fm_play
	
	; write to sid

	.IF DEBUGMODE = 1
	lda #$0b
	sta $d020
	.ENDIF
	
	ldx #$00	
sidplayloop
	stx drivernumber
	
	lda player_outputhi,x
	cmp #$ff
	beq skipsidoutputcall
	sta sidcall+$02
	lda player_outputlo,x
	sta sidcall+$01
	clc
	lda drivernumber
	adc sidregsflipflop
	tay
	lda sidregspointer,y
	adc #$18
	sta sidregsoffset+$01
	ldx #$18
sidregsoffset
	ldy #$00
sidwrite
	lda sidregs,y
sidcall
	sta $d400,x
	dey
	dex
	bpl sidwrite
skipsidoutputcall
	ldx drivernumber
	inx
	cpx #$04
	bne sidplayloop	

	jsr register_flip

	rts

driverrun
	lda #$00
drivercall
	jsr $1000
	rts

driver_callhi
	.byte $ff,$ff,$ff,$ff
driver_calllo
	.byte $ff,$ff,$ff,$ff

playerdelaycheck
	.byte $00
	

register_flip
	clc
	lda sidregsflipflop
	sta sidregsprevflipflop
	adc #$04
	and #$07
	sta sidregsflipflop

	rts
	

fm_play

	
	; work out fm channels
	
	ldx #$00
	stx fm_channel
	
fmloop
	stx drivernumber
	lda player_fmout,x 
	bmi fmskip
	

	jsr fmupdate
	
fmskip
	ldx drivernumber
	inx
	cpx #$04
	bne fmloop
	rts
	
	; sid read
	
sid_read

	ldx #$00	
	
	
driverloop
	stx drivernumber
	
	jsr sid_readmain	

	ldx drivernumber
	inx
	cpx #$04
	beq driverstop
	jmp driverloop
	
driverstop
	rts
	
sid_readmain




	ldx drivernumber
	lda driver_callhi,x 
	cmp #$ff
	beq skipdrivercall	
	sta drivercall+$02	
	lda driver_calllo,x 
	sta drivercall+$01

	jsr driverrun


skipdrivercall
	ldx drivernumber
	lda player_readsidhi,x
	cmp #$ff
	beq skipdriverread
	sta driverread+$02
	lda player_readsidlo,x
	sta driverread+$01
	clc
	txa
	adc sidregsflipflop
	tay
	lda sidregspointer,y
	adc #$18
	sta driverregsoffset+$01
	ldx #$18
driverregsoffset
	ldy #$00
driverread
	lda $d400,x
	sta sidregs,y
	dey
	dex
	bpl driverread
skipdriverread
	rts
	

	; do fm stuff for each sid
	
fmupdate



	ldx drivernumber
	txa
	clc
	adc sidregsflipflop
	tay
	lda sidregspointer,y
	sta sidregs_offsetcurrent
		
	txa
	clc
	adc sidregsprevflipflop
	tay
	lda sidregspointer,y
	sta sidregs_offsetlast
	
	lda #$00
fmupdate_loop
	sta sidregs_channel
	clc
	adc sidregs_offsetlast
	sta regsoffsetlast 
	tax
	
	lda sidregs_offsetcurrent 
	adc sidregs_channel
	sta regsoffsetnow 
	tay
	
	.IF DEBUGMODE = 1
	lda fm_channel
	sta $d020	
	.ENDIF
	
	ldx fm_channel
fmupdate_inittoggle
	lda #$ff
	sta fmwavesetbuffer,x
	sta fmadsetbuffer,x
	sta fmsrsetbuffer,x
	lda #$00
	sta instoverwrite,x
	sta gatechange,x
	sta notechange,x
	.IF MUTEZERO = 1
	sta temp2
	.ENDIF

	
	ldx regsoffsetlast	
	lda sidregs+$04,x
	and #$01
	sta temp
	lda sidregs+$04,y
	and #$01
	cmp temp
	beq fmupdate_donote
	asl
	asl
	asl
	asl
	asl
	ldy fm_channel
	sta fmgatebuffer,y
	lda #$01
	sta gatechange,y
	
	.IF SENDADSRONGATE = 1
	sta fmadsetbuffer,y
	sta fmsrsetbuffer,y
	.ENDIF
fmupdate_donote



	; update fm note
	
	
	ldy regsoffsetnow
	.IF FIXEDNOISE = 1	
	lda sidregs+$04,y
	bpl fmupdate_nonoisecheck2
	.IF METALWAVES = 1
	cmp #$8f
	bcc fmupdate_nometalwaves
	lda #$00
	jmp fmupdate_silencenote
fmupdate_nometalwaves
	.ENDIF
	lda sidregs+$01,y
	cmp #$00
	beq fmupdate_nonoisecheck2
	ldx fixed_noise_value
	;sta sidregs+$01,y
	lda #$00
	sta temp;sidregs+$00,y
	jmp fmupdate_straightinto	
fmupdate_nonoisecheck2
	.ENDIF
	
	lda sidregs,x
	cmp sidregs,y
	bne fmupdate_donoteyes
	lda sidregs+1,x
	cmp sidregs+1,y
	beq fmupdate_skipnote
	
fmupdate_donoteyes	
	lda sidregs+$01,y
	cmp #$00
	bne fmupdate_checkzeronote
fmupdate_silencenote
	.IF MUTEZERO = 1
	lda sidregs+$06,y
	sta temp2
	lda #$00
	sta sidregs+$06,y
	.ENDIF
	ldy fm_channel
	sta fmnotebufferl,y
	sta fmnotebufferh,y
	lda #$01
	sta notechange,y
	jmp fmupdate_dontsetsr
	
fmupdate_checkzeronote
	
	ldx sidregs,y
	lda $9400,x
	sta temp
	

	ldx sidregs+$01,y
fmupdate_straightinto	
	ldy $9600,x
	lda hexoffset,y
	sta writefmnotehi+$02
	lda hexoffset2,y
	sta writefmnotelo+$02
	

	clc
	lda $9500,x
	adc temp
	sta writefmnotelo+$01
	sta writefmnotehi+$01
	

	
writefmnotelo
	lda $7000
	
	ldy fm_channel
	sta fmnotebufferl,y
	
	 
writefmnotehi
	lda $8000	
	sta fmnotebufferh,y
	
	lda #$01
	sta notechange,y
	
fmupdate_skipnote

	

	; get volume
	ldy regsoffsetnow
	lda sidregs+$06,y
	and #$f0

	lsr
	lsr
	lsr
	lsr
	tax 	

fmupdate_replacevol
	lda fmvolume_replace,x	
	ldx fm_channel
	sta instoverwrite,x 
	

fmupdate_checkwaveform

	; update waveform
	

	
	ldx regsoffsetlast
	
	ldy regsoffsetnow

	
	.IF NEWWAVEHANDLE = 1
	; new wave code
	lda sidregs+$04,y
	cmp #$00
	bne fmupdate_notzero
	jmp fmupdate_skipinstrument
fmupdate_notzero	
	cmp #$10
	bcs fmupdate_comparewaves
	jmp fmupdate_hardrestart
fmupdate_comparewaves
	cmp sidregs+$04,x
	beq fmupdate_checkadsr
	jmp fmupdate_nothardrestart
	
	;waveform compare
fmupdate_hardrestart	
	ldx fm_channel
	lda channel_advanced_hardrestart,x
	bmi fmupdate_checkadsr

	lda #$3f
	sta instoverwrite,x 
	inc fmwavesetbuffer,x

	
	jmp fmupdate_checkadsr
fmupdate_nothardrestart
	and #$f0
	cmp #$8f ; if waveform > noise ignore waveform change
	bcc fmupdate_handleinstrument
	jmp fmupdate_skipinstrument
	.ELSE
	; old wave code
	lda sidregs+$04,x
	cmp sidregs+$04,y
	beq fmupdate_checkadsr
	
	;waveform compare
	lda sidregs+$04,y

	cmp #$00
	beq fmupdate_checkadsr
	cmp #$10 ; if 'hard restart' or anything before triangle ignore waveform change
	
	bcs fmupdate_nothardrestart
	
	ldx fm_channel
	lda channel_advanced_hardrestart,x
	bmi fmupdate_checkadsr

	lda #$3f
	sta instoverwrite,x 
	inc fmwavesetbuffer,x

	jmp fmupdate_checkadsr
fmupdate_nothardrestart
	and #$f0
	cmp #$90 ; if waveform > noise ignore waveform change
	bcc fmupdate_handleinstrument
	jmp fmupdate_skipinstrument
	.ENDIF
	
fmupdate_handleinstrument
	

	
	; do waveform update
	lsr
	lsr
	lsr
	lsr
	
	ldx fm_channel
	sta fminstnumber,x
	dec fminstnumber,x
	


notnoise
	
	inc fmwavesetbuffer,x


fmupdate_checkadsr

	
	; only force adsr reset on the first frame of the gate on an instrument.
	ldx fm_channel
	; commented out
	lda gatechange,x
	cmp #$00
	bne fmupdate_doinstrument
	jmp fmupdate_skipinstrument
fmupdate_doinstrument	
	; commented out
	ldy regsoffsetnow
	lda sidregs+$04,y
fmupdate_nothr
	and #$01
	cmp #$01
	beq fmupdate_skipforceadsr		
	jmp fmupdate_skipinstrument
	
fmupdate_skipforceadsr	

	; fm sr + volume checks
	
	ldx fm_channel	
	lda firstpass,x
	bmi fmupdate_checksustain
	dec firstpass,x
	jmp fmupdate_dosustain
	
	
fmupdate_checksustain
	IF SENDADSRONGATE = 1
	lda fmsrsetbuffer,x
	bpl fmupdate_dosustain
	.ENDIF
	
	ldx regsoffsetlast
	lda sidregs+$06,x
	cmp sidregs+$06,y
	bne fmupdate_dosustain
	
	ldx fm_channel
	lda #$ff
	sta fmsrsetbuffer,x
	jmp fmupdate_nosustain
		
fmupdate_dosustain

	

	; sustain
	lda sidregs+$06,y
	and #$f0
	
	lsr
	lsr
	lsr
	lsr
	tax
	lda fmsustain_replace,x
	sta temp
	
	lda sidregs+$06,y	
	and #$0f
	
	
	tay
	lda fmrelease_replace,y
	clc
	adc temp

	ldx fm_channel
	sta sroverwrite,x 
	
	
	inc fmsrsetbuffer,x 
	

	.IF MUTEZERO = 1
	lda temp2
	cmp #$00
	beq fmupdate_nosustain
	ldy regsoffsetnow
	sta $d406,y
	.ENDIF
	
fmupdate_nosustain


 	ldy regsoffsetnow

	
 	;adsr  AR
	
	ldx fm_channel
	lda firstpass,x
	bmi fmupdate_checkad
	dec firstpass,x
	jmp fmupdate_doadecay

fmupdate_checkad

	IF SENDADSRONGATE = 1
	lda fmsrsetbuffer,x
	bpl fmupdate_doadecay
	.ENDIF
	
	ldx regsoffsetlast
	lda sidregs+$05,x
	cmp sidregs+$05,y
	beq fmupdate_noadecay 
	

fmupdate_doadecay
	
	lda sidregs+$05,y
	and #$f0
	lsr
	lsr
	lsr
	lsr
	tax
	lda fmattack_replace,x
	sta temp
	lda sidregs+$05,y
	and #$0f
	
	tay
	lda fmdecay_replace,y
	clc
	adc temp
	ldx fm_channel
	sta adoverwrite,x 

	inc fmadsetbuffer,x 


fmupdate_noadecay
fmupdate_skipinstrument


	
	clc
	lda fm_channel
	tay

	asl
	asl
	asl
	adc fminstnumber,y
	
	tax
	lda fm_instoffsetlo,x
	sta $08
	
	clc
	lda fm_instoffsethi,x

	sta $09	
	
	
	ldx fm_channel
	lda fmwavesetbuffer,x 
	bmi fmupdate_dontsetwave
	
	; set wave
	ldy #$00	
	jsr fm_setinstrument
	
	ldx fm_channel
	ldy #$03
	lda ($08),y
	cmp #$00
	beq fmupdate_standardkey
	cmp #$02
	beq fmupdate_standardkey1
	pha
	iny
	clc
	lda ($08),y
	and #$c0
	adc instoverwrite,x
	sta ($08),y
	pla
	cmp #$03
	bne fmupdate_standardkey
fmupdate_standardkey1
	ldy #$05
	clc
	lda ($08),y
	and #$c0
	adc instoverwrite,x
	sta ($08),y	
		
fmupdate_standardkey	
	ldy #$04
	jsr fm_setkey


fmupdate_dontsetwave


	; set AD
	ldx fm_channel
	lda fmadsetbuffer,x 
	bmi fmupdate_dontsetad

	ldy #$06
	lda ($08),y
	cmp #$00
	beq fmupdate_standardad
	cmp #$02
	beq fmupdate_standardad1
	pha
	iny
	lda adoverwrite,x
	sta ($08),y
	pla
	cmp #$03
	bne fmupdate_standardad
fmupdate_standardad1
	ldy #$08
	lda adoverwrite,x
	sta ($08),y	
fmupdate_standardad	
	ldy #$07
	jsr fm_setad
		
fmupdate_dontsetad

	; set SR

	ldx fm_channel
	lda fmsrsetbuffer,x 
	bmi fmupdate_dontsetsr

	ldy #$09
	lda ($08),y
	
	cmp #$00
	beq fmupdate_standardsr
	cmp #$02
	beq fmupdate_standardsr1
	pha
	iny
	lda sroverwrite,x
	sta ($08),y
	pla
	cmp #$03
	bne fmupdate_standardsr
fmupdate_standardsr1
	ldy #$0b
	lda sroverwrite,x
	sta ($08),y	
fmupdate_standardsr
	ldy #$0a
	jsr fm_setsr
	
	
fmupdate_dontsetsr

	; play notes
	

	.IF OPTIMIZENOTE = 1
	ldx fm_channel
	lda notechange,x
	cmp #$00
	bne doplaynotel 
	lda gatechange,x
	cmp #$00
	beq dontplaynoteh
	.ENDIF
	
doplaynotel
	clc
	lda #$a0
	adc fm_channel
	sta $df40
		
	ldx fm_channel
	lda fmnotebufferl,x

	jsr nopfest
	

dontplaynotel



doplaynoteh	
	clc
	lda #$b0
	adc fm_channel	
	sta $df40
	

	clc
	ldx fm_channel
	lda fmnotebufferh,x

	adc fmgatebuffer,x
	jsr nopfest
	
dontplaynoteh	
	.IF DEBUGMODE = 1
	ldx fm_channel
	ldy fmwavesetbuffer,x
	iny
	lda debugdisp,y
	sta $0400,x
	ldy notechange,x
	
	lda debugdisp,y
	sta $0428,x
	ldy gatechange,x
	
	lda debugdisp,y
	sta $0450,x
	lda fminstnumber,x
	clc
	adc #$31
	sta $0478,x
	.ENDIF

	
	

	inc fm_channel
	
	
	
	clc
	lda sidregs_channel
	adc #$07
	cmp #$15
	beq fmupdate_stop
	jmp fmupdate_loop

fmupdate_stop	

	rts

	.IF DEBUGMODE = 1
debugdisp .byte 91,160
	.ENDIF
	
instoverwrite
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00
adoverwrite
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00
sroverwrite
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00
	
regsoffsetlast
	.byte $00
regsoffsetnow
	.byte $00
	
notechange
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00
	
gatechange
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00	
	

sidregs_offsetcurrent
	.byte $00
sidregs_offsetlast
	.byte $04
sidregs_channel
	.byte $00

	


hexoffset
	.byte $70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7a,$7b,$7c,$7d,$7e,$7f
hexoffset2
	.byte $80,$81,$82,$83,$84,$85,$86,$87,$88,$89,$8a,$8b,$8c,$8d,$8e,$8f
		
	
fm_channel
	.byte $00
	
drivernumber
	.byte $00

firstpass
	.byte $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	
fmwavesetbuffer
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00
fmadsetbuffer
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00
fmsrsetbuffer
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00

fminstnumber
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00

fmgatebuffer
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00

fmnotebufferl
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00
fmnotebufferh
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00


	
sidregsflipflop
	.byte $00
sidregsprevflipflop
	.byte $04
	
sidregspointer

	.byte $00,$19,$32,$4b
	.byte $64,$7d,$96,$af




temp
	.byte $00
temp2
	.byte $00


fm_setinstrument

	; feedback
		
	clc
	lda #$c0
	adc fm_channel
	sta $df40
	
	
	lda ($08),y
	jsr nopfest
	iny
	
	ldx fm_channel
	lda fm_waveoffset,x
	;amp op1
	sta $df40
	pha
	
	
	lda ($08),y
	jsr nopfest
	iny
	
	; amp op2
	pla
	clc
	adc #$03
	sta $df40
	jsr nopfest

	lda ($08),y
	sta $df50
	


	
	rts	



fm_setkey
	
	

	ldx fm_channel
	lda fm_waveoffset,x
	; key op1
	clc
	adc #$20
	pha
	sta $df40
	
	
	lda ($08),y
	jsr nopfest
	iny
	; key op2
	pla
	clc
	adc #$03
	sta $df40
	
	
	lda ($08),y
	jsr nopfest
	

	
	rts

fm_setad

	
	
	ldx fm_channel
	lda fm_adsroffset,x
	
	;AD op1
	pha
	sta $df40
	
	
	lda ($08),y
	jsr nopfest
	iny
	; AD op2
	pla
	clc
	adc #$03
	sta $df40
	
	
	lda ($08),y
	jsr nopfest
	rts
	
fm_setsr
	
	
	
	ldx fm_channel
	
	lda fm_adsroffset,x
	
	clc
	; SR op1
	adc #$20
	pha
	sta $df40
	
	
	lda ($08),y
	jsr nopfest
	iny
	; SR op2
	pla
	clc
	adc #$03
	sta $df40
	

	lda ($08),y
	jsr nopfest	
	rts
	
	
	
fm_waveoffset

			
	.byte	$20,$21,$22,$28,$29,$2a,$30,$31,$32


fm_adsroffset
	.byte	$60,$61,$62,$68,$69,$6a,$70,$71,$72
	
fm_instoffsetlo

	


	.byte $00,$0c,$18,$24,$30,$3c,$48,$54
	.byte $60,$6c,$78,$84,$90,$9c,$a8,$b4
	.byte $c0,$cc,$d8,$e4,$f0,$00,$0c,$18
	.byte $24,$30,$3c,$48,$54,$60,$6c,$78
	.byte $84,$90,$9c,$a8,$b4,$c0,$cc,$d8
	.byte $e4,$f0,$00,$0c,$18,$24,$30,$3c
	.byte $48,$54,$60,$6c,$78,$84,$90,$9c
	.byte $a8,$b4,$c0,$cc,$d8,$e4,$f0,$00
	.byte $0c,$18,$24,$30,$3c,$48,$54,$60

fm_instoffsethi

	.byte $90,$90,$90,$90,$90,$90,$90,$90
	.byte $90,$90,$90,$90,$90,$90,$90,$90
	.byte $90,$90,$90,$90,$90,$91,$91,$91
	.byte $91,$91,$91,$91,$91,$91,$91,$91
	.byte $91,$91,$91,$91,$91,$91,$91,$91
	.byte $91,$91,$92,$92,$92,$92,$92,$92
	.byte $92,$92,$92,$92,$92,$92,$92,$92
	.byte $92,$92,$92,$92,$92,$92,$92,$93
	.byte $93,$93,$93,$93,$93,$93,$93,$93
	

	
	
	.include fmx-song.asm 
	
	
	
	org $7000-2
	.IF NTSC = 0
	.incbin fmdata_pal.prg
	.ELSE
	.incbin fmdata_ntsc.prg
	.ENDIF

	
	org $9000
	.include fmx-instruments.asm
	
	org $9400-2
	.incbin fmoffsets.prg
	
	org $9700
	.include fmx-globals.asm
	
	
patch_sids
	ldx #$00
patch_sids_loop
	stx drivernumber
	lda player_patchsid,x
	cmp #$ff
	bne patch_sids_continue
	lda player_readsidhi,x
	cmp #$ff
	beq patch_sids_skip
	lda player_patchreplacemem+$01
	sta player_readsidhi,x
	jmp patch_sids_skip
patch_sids_continue
	sta player_patchread+$02
	sta player_patchwrite+$02
	
	clc
	sbc #$00
	sta patch_compare+$02
	
	adc #$01
	clc
	adc player_patchsid_threshold,x
	sta player_patchcompare+$01
	
	lda patch_memory,x
	sta player_patchwritekey+$01
	sta player_patchreplacemem+$01
	ldy #$00
player_patchread
	lda $1000,y
	cmp player_readsidhi,x
	bne player_patchskip
	
patch_compare
	lda $0ffe,y
	cmp #$8d
	beq player_patchwritekey
	cmp #$9d
	beq player_patchwritekey
	cmp #$99
	beq player_patchwritekey
	cmp #$8e
	beq player_patchwritekey
	cmp #$8c
	bne player_patchskip
player_patchwritekey
	lda #$e0
player_patchwrite
	sta $1000,y
	
player_patchskip	
	iny
	cpy #$00
	bne player_patchread
	inc patch_compare+$02
	inc player_patchwrite+$02
	inc player_patchread+$02
	lda player_patchread+$02
player_patchcompare
	cmp #$00
	bne player_patchread	
player_patchreplacemem
	lda #$e0
	sta player_readsidhi,x

patch_sids_skip
	ldx drivernumber
	inx
	cpx #$04
	beq patch_sids_end
	jmp patch_sids_loop
patch_sids_end	
	
	rts

	.IF REPLAYMODE = 0
	org $9800
frontend
	.IF DEBUGMODE = 0
	lda color_border
	sta $d020
	lda color_page
	sta $d021
	.ENDIF
	ldx #$00
	lda #$20
clearscreen
	sta $0400,x
	sta $0500,x
	sta $0600,x
	sta $0700,x
	inx 
	bne clearscreen
clearvisual
	lda $9e00,x
	sta $04f0,x
	lda $9f00,x
	sta $05f0,x
	.IF DEBUGMODE = 0
	lda color_ink
	.ELSE
	lda #$0e
	.ENDIF
	sta $d8f0,x
	sta $d9f0,x
	inx
	bne clearvisual
	lda #$00
clearscratch	
	sta $9c00,x
	sta $9d00,x
	sta $9e00,x
	sta $9f00,x
	inx
	bne clearscratch

	ldx #$00
pastesong
	lda songname,x
	cmp #$00
	beq pastesongstop
	jsr translate
	sta $0520,x
	inx
	cpx #31
	bne pastesong
pastesongstop

	ldx #$00
pasteauthor
	lda author,x
	cmp #$00
	beq pasteauthorstop
	jsr translate
	sta $0549,x
	inx
	cpx #30
	bne pasteauthor
pasteauthorstop

	ldx #$00
pasterelease
	lda release,x
	cmp #$00
	beq pastereleasestop
	jsr translate
	sta $0573,x
	inx
	cpx #28
	bne pasterelease
pastereleasestop

	ldx #$00
	ldy #$00
pasteinit1
	lda player_inithi,x
	cmp #$ff
	beq pasteread1
	jsr gethex
	lda hexdisp
pasteinit 
	sta $05c6,y
	lda hexdisp+$01
	sta $05c7,y
	lda player_initlo,x
	jsr gethex
	lda hexdisp
	sta $05c8,y
	lda hexdisp+$01
	sta $05c9,y
pasteread1
	lda player_readsidhi,x
	cmp #$ff
	beq pastefm1
	jsr gethex
	lda hexdisp
pasteread
	sta $05ee,y
	lda hexdisp+$01
	sta $05ef,y
	lda player_readsidlo,x
	jsr gethex
	lda hexdisp
	sta $05f0,y
	lda hexdisp+$01
	sta $05f1,y	
pastefm1
	lda player_fmout,x
	cmp #$ff
	beq pastwrite1
	lda #$19
pastefm
	sta $0617,y
pastwrite1
	lda player_outputhi,x
	cmp #$ff
	beq pasteend
	jsr gethex
	lda hexdisp
pastewrite
	sta $063e,y
	lda hexdisp+$01
	sta $063f,y
	lda player_outputlo,x
	jsr gethex
	lda hexdisp
	sta $0640,y
	lda hexdisp+$01
	sta $0641,y	
pasteend
	iny
	iny
	iny
	iny
	iny
	iny
	iny
	inx
	cpx #$04
	beq pastestop
	jmp pasteinit1
pastestop
	rts

gethex 
	sty temp
	pha
	and #$0f
	tay
	lda hexchars,y
	sta hexdisp+$01
	pla
	lsr
	lsr
	lsr
	lsr
	tay
	lda hexchars,y
	sta hexdisp
	ldy temp
	rts

hexdisp
	.byte $00,$00
	
hexchars .byte $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$01,$02,$03,$04,$05,$06

translate
	cmp #$40
	bcc translateout
	clc
	sbc #$5f
translateout
	rts

	org $9e00-2
	.incbin fmgui.prg
	.ENDIF
	
	
	
	